//+------------------------------------------------------------------+
//|                                                   Swing line.mq4 |
//|                                                                  |
//| September 2010 issue                                             |
//| Technical Analysis of Stocks and Commodities                     |
//| Ron Black's article Getting Clear With Short-Term Swings       |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  7
#property indicator_color1   clrDimGray
#property indicator_color2   clrDimGray
#property indicator_color3   clrDeepSkyBlue
#property indicator_color4   clrSandyBrown
#property indicator_color5   clrDeepSkyBlue
#property indicator_color6   clrSandyBrown
#property indicator_color7   clrSandyBrown
#property indicator_width5   3
#property indicator_width6   3
#property indicator_width7   3

//
//
//
//
//

extern int TimeFrame = PERIOD_CURRENT;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern int    BodyWidth       = 1;
extern int    WickWidth       = 1;
extern bool   DrawLines       = true;
extern bool   DrawBars        = false;
extern bool   DrawCandles     = false;
extern bool   Interpolate     = false;

//
//
//
//
//

double swli[];
double swda[];
double swdb[];
double trend[];
double swwu[];
double swwd[];
double swbu[];
double swbd[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   int type1 = DRAW_NONE; if (DrawLines) type1 = DRAW_LINE;
   IndicatorBuffers(8); 
   SetIndexBuffer(0,swwu); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(1,swwd); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(2,swbu); SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,BodyWidth);
   SetIndexBuffer(3,swbd); SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,BodyWidth);
   SetIndexBuffer(4,swli); SetIndexStyle(4,type1);
   SetIndexBuffer(5,swda); SetIndexStyle(5,type1);
   SetIndexBuffer(6,swdb); SetIndexStyle(6,type1);
   SetIndexBuffer(7,trend);

   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      
   IndicatorShortName("Swing line "+timeFrameToString(TimeFrame));
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  work[][4];
#define hHi 0
#define hLo 1
#define lHi 2
#define lLo 3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { swwu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

      //
      //
      //
      //
      //
      
      if (trend[limit] == -1) CleanPoint(limit,swda,swdb);
      for(int i=limit,r=Bars-limit-1; i>=0; i--,r++)
      {
         if (i==Bars-1)
         {
            work[r][hHi] = High[i]; work[r][hLo] = Low[i];
            work[r][lHi] = High[i]; work[r][lLo] = Low[i];
            trend[i]     = -1;
            continue; 
         }
      
         //
         //
         //
         //
         //
      
         trend[i]     = trend[i+1];
         work[r][hHi] = work[r-1][hHi]; work[r][hLo] = work[r-1][hLo];
         work[r][lHi] = work[r-1][lHi]; work[r][lLo] = work[r-1][lLo];
 
               if (trend[i+1] == 1)
               {
                  work[r][hHi] = MathMax(work[r-1][hHi],High[i]);
                  work[r][hLo] = MathMax(work[r-1][hLo],Low[i]);
                     if (High[i]<work[r][hLo]) { trend[i] = -1; work[r][lHi] = High[i]; work[r][lLo] = Low[i]; }
               }
               if (trend[i+1] == -1)
               {
                  work[r][lHi] = MathMin(work[r-1][lHi],High[i]);
                  work[r][lLo] = MathMin(work[r-1][lLo],Low[i]);
                     if (Low[i]>work[r][lHi]) { trend[i] =  1; work[r][hHi] = High[i]; work[r][hLo] = Low[i]; }
               }

         if (trend[i]==1)      
               swli[i] = work[r][hLo];
         else  swli[i] = work[r][lHi];
         manageBar(i); swda[i] = EMPTY_VALUE; swdb[i] = EMPTY_VALUE; if (trend[i] == -1) PlotPoint(i,swda,swdb,swli);
      }
      manageAlerts();
      return(0);
   }            
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trend[limit] == -1) CleanPoint(limit,swda,swdb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         swli[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
         swda[i]  = EMPTY_VALUE; 
         swdb[i]  = EMPTY_VALUE;
         manageBar(i);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++)
               swli[i+k] = k*factor*swli[i+n] + (1.0-k*factor)*swli[i];
   }
   for(i=limit; i>=0; i--) if (trend[i] == -1) PlotPoint(i,swda,swdb,swli); 
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageBar(int i )
{
   if (!DrawBars && !DrawCandles) return;
   if (DrawCandles) {  swwu[i] = High[i]; swwd[i] = Low[i]; }
   if (trend[i]==1)
      if (DrawCandles)
            { swbu[i] = MathMax(Open[i],Close[i]); swbd[i] = MathMin(Open[i],Close[i]); }
      else  { swbu[i] = High[i];                   swbd[i] = Low[i];                    }                 
   else
      if (DrawCandles)
            { swbu[i] = MathMin(Open[i],Close[i]); swbd[i] = MathMax(Open[i],Close[i]); }
      else  { swbu[i] = Low[i];                    swbd[i] = High[i];                   }                 
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," "+timeFrameToString(_Period)+" Swing line changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Swing line "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
string StringUpperCase(string str) { string s = str; StringToUpper(s); return(s); }